--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #FileDialog
  me.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
	obj._class = #FileDialog
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- selectedFiles () -> list
on selectedFiles (me)
  return $.Qt._qx.callWidget(me._id,#selectedFiles)
end

-- selectFile (string)
on selectFile (me,p1)
  $.Qt._qx.callWidget(me._id,#selectFile,p1)
end

-- setAcceptMode (int)
on setAcceptMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setAcceptMode,p1)
end

-- setDefaultSuffix (string)
on setDefaultSuffix (me,p1)
  $.Qt._qx.callWidget(me._id,#setDefaultSuffix,p1)
end

-- setDirectory (string)
on setDirectory (me,p1)
  $.Qt._qx.callWidget(me._id,#setDirectory,p1)
end

-- setFileMode (int)
on setFileMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setFileMode,p1)
end

-- setFilter (int)
on setFilter (me,p1)
  $.Qt._qx.callWidget(me._id,#setFilter,p1)
end

-- setLabelText (int,string)
on setLabelText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setLabelText,p1,p2)
end

-- setNameFilters (list)
on setNameFilters (me,p1)
  $.Qt._qx.callWidget(me._id,#setNameFilters,p1)
end

-- setOption (int,bool)
on setOption (me,p1,p2)
	if voidP(p2) then $.Qt._qx.callWidget(me._id,#setOption,p1)
  else $.Qt._qx.callWidget(me._id,#setOption,p1,p2)
end

-- setSidebarUrls (list)
on setSidebarUrls (me,p1)
  $.Qt._qx.callWidget(me._id,#setSidebarUrls,p1)
end

-- setViewMode (int)
on setViewMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setViewMode,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- getExistingDirectory (WidgetID,string,string,*int) -> string
on getExistingDirectory (scr,p1,p2,p3,p4)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#FileDialog,#getExistingDirectory,p1,p2,p3,p4)
end

-- getOpenFileName (WidgetID,string,string,string,*int) -> string
on getOpenFileName (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#FileDialog,#getOpenFileName,p1,p2,p3,p4,p5)
end

-- getOpenFileNames (WidgetID,string,string,string,*int) -> list
on getOpenFileNames (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#FileDialog,#getOpenFileNames,p1,p2,p3,p4,p5)
end

-- getSaveFileName (WidgetID,string,string,filter,*int) -> string
on getSaveFileName (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#FileDialog,#getSaveFileName,p1,p2,p3,p4,p5)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentChanged -> string
on currentChanged(me,id,p1)
  me._detach(#currentChanged,me,p1)
end

-- directoryEntered -> string
on directoryEntered(me,id,p1)
  me._detach(#directoryEntered,me,p1)
end

-- fileSelected -> string
on fileSelected(me,id,p1)
  me._detach(#fileSelected,me,p1)
end

-- filesSelected -> list
on filesSelected(me,id,p1)
  me._detach(#filesSelected,me,p1)
end

-- filterSelected -> string filter
on filterSelected(me,id,p1)
  me._detach(#filterSelected,me,p1)
end
