--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me)
  me._class = #Font
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Font
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- bold () -> bool
on bold (me)
  return $.Qt._qx.callObject(me._id,#bold)
end

-- capitalization () -> int
on capitalization (me)
  return $.Qt._qx.callObject(me._id,#capitalization)
end

-- family () -> string
on family (me)
  return $.Qt._qx.callObject(me._id,#family)
end

-- fromString (string)
on fromString (me,p1)
  $.Qt._qx.callObject(me._id,#fromString,p1)
end

-- italic () -> bool
on italic (me)
  return $.Qt._qx.callObject(me._id,#italic)
end

-- letterSpacing () -> float
on letterSpacing (me)
  return $.Qt._qx.callObject(me._id,#letterSpacing)
end

-- letterSpacingType () -> int
on letterSpacingType (me)
  return $.Qt._qx.callObject(me._id,#letterSpacingType)
end

-- pixelSize () -> int
on pixelSize (me)
  return $.Qt._qx.callObject(me._id,#pixelSize)
end

-- pointSize () -> float
on pointSize (me)
  return $.Qt._qx.callObject(me._id,#pointSize)
end

-- setBold (bool)
on setBold (me,p1)
  $.Qt._qx.callObject(me._id,#setBold,p1)
end

-- setCapitalization (int)
on setCapitalization (me,p1)
  $.Qt._qx.callObject(me._id,#setCapitalization,p1)
end

-- setFamily (string)
on setFamily (me,p1)
  $.Qt._qx.callObject(me._id,#setFamily,p1)
end

-- setItalic (bool)
on setItalic (me,p1)
  $.Qt._qx.callObject(me._id,#setItalic,p1)
end

-- setLetterSpacing (int,float)
on setLetterSpacing (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setLetterSpacing,p1,p2)
end

-- setPixelSize (int)
on setPixelSize (me,p1)
  $.Qt._qx.callObject(me._id,#setPixelSize,p1)
end

-- setPointSize (int|float)
on setPointSize (me,p1)
  $.Qt._qx.callObject(me._id,#setPointSize,p1)
end

-- setStretch (int)
on setStretch (me,p1)
  $.Qt._qx.callObject(me._id,#setStretch,p1)
end

-- setStrikeOut (bool)
on setStrikeOut (me,p1)
  $.Qt._qx.callObject(me._id,#setStrikeOut,p1)
end

-- setUnderline (bool)
on setUnderline (me,p1)
  $.Qt._qx.callObject(me._id,#setUnderline,p1)
end

-- setWordSpacing (float)
on setWordSpacing (me,p1)
  $.Qt._qx.callObject(me._id,#setWordSpacing,p1)
end

-- stretch () -> int
on stretch (me)
  return $.Qt._qx.callObject(me._id,#stretch)
end

-- strikeOut () -> bool
on strikeOut (me)
  return $.Qt._qx.callObject(me._id,#strikeOut)
end

-- toString () -> string
on toString (me)
  return $.Qt._qx.callObject(me._id,#toString)
end

-- underline () -> bool
on underline (me)
  return $.Qt._qx.callObject(me._id,#underline)
end

-- wordSpacing () -> float
on wordSpacing (me)
  return $.Qt._qx.callObject(me._id,#wordSpacing)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------
