--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1)
  me._class = #UiLoader
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  	me._id = $.Qt._qx.newObject(me._class,p1)
	else
  	me._id = $.Qt._qx.newObject(me._class)
	end if
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #UiLoader
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- load (string,*WidgetID) -> WidgetID
on load (me,p1,p2)
	if voidP(p2) then
		id = $.Qt._qx.callObject(me._id,#load,p1)
	else
		if ilk(p2)=#instance then p2 = p2._id
		id = $.Qt._qx.callObject(me._id,#load,p1,p2)
	end if	
  if id then
    cn = $.Qt._qx.callWidget(id, #className)
    delete char 1 of cn
    class = value("$.Qt."&cn)
    if ilk(class)<>#script then class = $.Qt.Widget
    obj = class._make(id)
    me._children.add(obj)
    return obj
  end if
end

-- addPluginPath (string)
on addPluginPath (me,p1)
  $.Qt._qx.callObject(me._id,#addPluginPath,p1)
end

-- availableLayouts () -> list
on availableLayouts (me)
  return $.Qt._qx.callObject(me._id,#availableLayouts)
end

-- availableWidgets () -> list
on availableWidgets (me)
  return $.Qt._qx.callObject(me._id,#availableWidgets)
end

-- clearPluginPaths ()
on clearPluginPaths (me)
  $.Qt._qx.callObject(me._id,#clearPluginPaths)
end

-- setWorkingDirectory (string)
on setWorkingDirectory (me,p1)
  $.Qt._qx.callObject(me._id,#setWorkingDirectory,p1)
end

-- createWidget (string className) -> int widgetID
on createWidget (me,p1)
  return $.Qt._qx.callObject(me._id,#createWidget,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------
