--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #HexEdit
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #HexEdit
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- data () -> bytearray
on data (me)
  return $.Qt._qx.callWidget(me._id,#data)
end

-- ensureCursorVisible ()
on ensureCursorVisible (me)
  $.Qt._qx.callWidget(me._id,#ensureCursorVisible)
end

-- isModified () -> bool
on isModified (me)
  return $.Qt._qx.callWidget(me._id,#isModified)
end

-- redo ()
on redo (me)
  $.Qt._qx.callWidget(me._id,#redo)
end

-- setAddressAreaColor (color)
on setAddressAreaColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setAddressAreaColor,p1)
end

-- setData (bytearray)
on setData (me,p1)
  $.Qt._qx.callWidget(me._id,#setData,p1)
end

-- setViewportPalette (int objectID)
on setViewportPalette (me,p1)
  if ilk(p1)=#instance then  p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setViewportPalette,p1)
end

-- undo ()
on undo (me)
  $.Qt._qx.callWidget(me._id,#undo)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- dataChanged
on dataChanged(me,id)
  me._detach(#dataChanged,me)
end
