--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Menu
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #Menu
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- activeAction () -> action
on activeAction (me)
	obj = $.Qt.Action._make($.Qt._qx.callWidget(me._id,#activeAction))
  me._children.add(obj)
  return obj
end

-- addAction (ActionID)
on addAction (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#addAction,p1)
end

-- addMenu (string) -> menu
on addMenu (me,p1)
  obj = $.Qt.Menu._make($.Qt._qx.callWidget(me._id,#addMenu,p1))
  me._children.add(obj)
  return obj
end

-- addSeparator ()
on addSeparator (me)
  $.Qt._qx.callWidget(me._id,#addSeparator)
end

-- clear ()
on clear (me)
  $.Qt._qx.callWidget(me._id,#clear)
end

-- exec ()
on exec (me)
  $.Qt._qx.callWidget(me._id,#exec)
end

-- menuAction () -> action
on menuAction (me)
	obj = $.Qt.Action._make($.Qt._qx.callWidget(me._id,#menuAction))
  me._children.add(obj)
  return obj
end

-- setTitle (string)
on setTitle (me,p1)
  $.Qt._qx.callWidget(me._id,#setTitle,p1)
end

-- title_ () -> string
on title_ (me)
  return $.Qt._qx.callWidget(me._id,#title)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- triggered -> string
on triggered(me,id,p1)
  me._detach(#triggered,me,p1)
end
