--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #ScrollArea
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #ScrollArea
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- ensureVisible (int,int)
on ensureVisible (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#ensureVisible,p1,p2)
end

-- ensureWidgetVisible (WidgetID)
on ensureWidgetVisible (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#ensureWidgetVisible,p1)
end

-- setAlignment (int)
on setAlignment (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlignment,p1)
end

-- setWidget (WidgetID)
on setWidget (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setWidget,p1)
end

-- setWidgetResizable (bool)
on setWidgetResizable (me,p1)
  $.Qt._qx.callWidget(me._id,#setWidgetResizable,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------
