--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.3
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TabWidget
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TabWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addTab (WidgetID,string,*string|image) -> int
on addTab (me,p1,p2,p3)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(me._id,#addTab,p1,p2,p3)
end

-- count () -> int
on count_ (me)
  return $.Qt._qx.callWidget(me._id,#count)
end

-- currentIndex () -> int
on currentIndex (me)
  return $.Qt._qx.callWidget(me._id,#currentIndex)
end

-- insertTab (int,WidgetID,string,*string|image) -> int
on insertTab (me,p1,p2,p3,p4)
  if ilk(p2)=#instance then p2 = p2._id
  return $.Qt._qx.callWidget(me._id,#insertTab,p1,p2,p3,p4)
end

-- removeTab (int)
on removeTab (me,p1)
  $.Qt._qx.callWidget(me._id,#removeTab,p1)
end

-- setCurrentIndex (int)
on setCurrentIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setCurrentIndex,p1)
end

-- setElideMode (int)
on setElideMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setElideMode,p1)
end

-- setMovable (bool)
on setMovable (me,p1)
  $.Qt._qx.callWidget(me._id,#setMovable,p1)
end

-- setShape (int)
on setShape (me,p1)
  $.Qt._qx.callWidget(me._id,#setShape,p1)
end

-- setTabEnabled (int,bool)
on setTabEnabled (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setTabEnabled,p1,p2)
end

-- setTabsClosable (bool)
on setTabsClosable (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabsClosable,p1)
end

-- setTabText (int,string)
on setTabText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setTabText,p1,p2)
end

-- setTabToolTip int,string)
on setTabToolTip (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setTabToolTip,p1,p2)
end

-- setTabWhatsThis (int,string)
on setTabWhatsThis (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setTabWhatsThis,p1,p2)
end

-- setUsesScrollButtons (bool)
on setUsesScrollButtons (me,p1)
  $.Qt._qx.callWidget(me._id,#setUsesScrollButtons,p1)
end

-- tabText (int) -> string
on tabText (me,p1)
  return $.Qt._qx.callWidget(me._id,#tabText,p1)
end

-- tabToolTip (int index) -> string
on tabToolTip (me,p1)
  return $.Qt._qx.callWidget(me._id,#tabToolTip,p1)
end

-- widgetAt (int) -> WidgetID
on widgetAt (me,p1)
  obj = $.Qt.Widget._make($.Qt._qx.callWidget(me._id,#widgetAt,p1))
  me._children.add(obj)
  return obj
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentChanged -> int
on currentChanged(me,id,p1)
  me._detach(#currentChanged,me,p1)
end

-- tabCloseRequested -> int
on tabCloseRequested(me,id,p1)
  me._detach(#tabCloseRequested,me,p1)
end

-- tabMoved -> int,int
on tabMoved(me,id,p1,p2)
  me._detach(#tabMoved,me,p1,p2)
end
