--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TableWidget
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TableWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- columnCount () -> int
on columnCount (me)
  return $.Qt._qx.callWidget(me._id,#columnCount)
end

-- currentItem () -> TableWidgetItemID
on currentItem (me)
  obj = $.Qt.TableWidgetItem._make($.Qt._qx.callWidget(me._id,#currentItem))
  me._children.add(obj)
  return obj
end

-- item (int,int) -> TableWidgetItemID
on item_ (me,p1,p2)
  obj = $.Qt.TableWidgetItem._make($.Qt._qx.callWidget(me._id,#item,p1,p2))
  me._children.add(obj)
  return obj
end

-- rowCount () -> int
on rowCount (me)
  return $.Qt._qx.callWidget(me._id,#rowCount)
end

-- selectedItems () -> TableWidgetItemIDs
on selectedItems (me)
  return $.Qt._qx.callWidget(me._id,#selectedItems)
end

-- setAlternatingRowColors (bool)
on setAlternatingRowColors (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlternatingRowColors,p1)
end

-- setColumnCount (int)
on setColumnCount (me,p1)
  $.Qt._qx.callWidget(me._id,#setColumnCount,p1)
end

-- setCurrentCell (int,int)
on setCurrentCell (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setCurrentCell,p1,p2)
end

-- setCurrentItem (TableWidgetItemID)
on setCurrentItem (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCurrentItem,p1)
end

-- setItem (int,int,TableWidgetItemID)
on setItem (me,p1,p2,p3)
  if ilk(p3)=#instance then p3 = p3._id
  $.Qt._qx.callWidget(me._id,#setItem,p1,p2,p3)
end

-- setRowCount (int)
on setRowCount (me,p1)
  $.Qt._qx.callWidget(me._id,#setRowCount,p1)
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
  $.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- sortItems (int,int)
on sortItems (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#sortItems,p1,p2)
end

-- setHorizontalHeaderLabels (list)
on setHorizontalHeaderLabels (me,p1)
  $.Qt._qx.callWidget(me._id,#setHorizontalHeaderLabels,p1)
end

-- setVerticalHeaderLabels (list)
on setVerticalHeaderLabels (me,p1)
  $.Qt._qx.callWidget(me._id,#setVerticalHeaderLabels,p1)
end

--setCellWidget(int row, int column, QWidget * widget)
on setCellWidget (me,p1,p2,p3)
  if ilk(p3)=#instance then
    --me._children.add(p3) -- ???
    p3 = p3._id
  end if
  $.Qt._qx.callWidget(me._id,#setCellWidget,p1,p2,p3)
end

--removeCellWidget(int row, int column)
on removeCellWidget (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#removeCellWidget,p1,p2)
end

--resizeRowsToContents()
on resizeRowsToContents (me)
  $.Qt._qx.callWidget(me._id,#resizeRowsToContents)
end

--setColumnWidth(int column, int width)
on setColumnWidth (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setColumnWidth,p1,p2)
end

--setStretchLastSection (bool flag)
on setStretchLastSection (me,p1)
  $.Qt._qx.callWidget(me._id,#setStretchLastSection,p1)
end

--setResizeMode (int mode)
on setResizeMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setResizeMode,p1)
end

--setVerticalHeaderVisible (bool flag)
on setVerticalHeaderVisible (me,p1)
  $.Qt._qx.callWidget(me._id,#setVerticalHeaderVisible,p1)
end

--setHorizontalHeaderDefaultAlignment (int alignment)
on setHorizontalHeaderDefaultAlignment (me,p1)
  $.Qt._qx.callWidget(me._id,#setHorizontalHeaderDefaultAlignment,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- cellActivated -> int,int
on cellActivated(me,id,p1,p2)
  me._detach(#cellActivated,me,p1,p2)
end

-- cellChanged -> int,int
on cellChanged(me,id,p1,p2)
  me._detach(#cellChanged,me,p1,p2)
end

-- cellClicked -> int,int
on cellClicked(me,id,p1,p2)
  me._detach(#cellClicked,me,p1,p2)
end

-- cellDoubleClicked -> int,int
on cellDoubleClicked(me,id,p1,p2)
  me._detach(#cellDoubleClicked,me,p1,p2)
end

-- cellEntered -> int,int
on cellEntered(me,id,p1,p2)
  me._detach(#cellEntered,me,p1,p2)
end

-- cellPressed -> int,int
on cellPressed(me,id,p1,p2)
  me._detach(#cellPressed,me,p1,p2)
end
