--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #ToolBox
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #ToolBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addItem (WidgetID,string,*string|image) -> int
on addItem (me,p1,p2,p3)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(me._id,#addItem,p1,p2,p3)
end

-- currentIndex () -> int
on currentIndex (me)
  return $.Qt._qx.callWidget(me._id,#currentIndex)
end

-- insertItem (int,WidgetID,string,*string|image) -> int
on insertItem (me,p1,p2,p3,p4)
  if ilk(p2)=#instance then p2 = p2._id
  return $.Qt._qx.callWidget(me._id,#insertItem,p1,p2,p3,p4)
end

-- removeItem (int)
on removeItem (me,p1)
  $.Qt._qx.callWidget(me._id,#removeItem,p1)
end

-- setCurrentIndex (int)
on setCurrentIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setCurrentIndex,p1)
end

-- setItemEnabled (int,bool)
on setItemEnabled (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setItemEnabled,p1,p2)
end

-- setItemIcon (int,string|image)
on setItemIcon (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setItemIcon,p1,p2)
end

-- setItemText (int,string)
on setItemText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setItemText,p1,p2)
end

-- widgetAt (int) -> WidgetID
on widgetAt (me,p1)
  obj = $.Qt.Widget._make($.Qt._qx.callWidget(me._id,#widgetAt,p1))
  me._children.add(obj)
  return obj
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentChanged -> int
on currentChanged(me,id,p1)
  me._detach(#currentChanged,me,p1)
end
